;**********************************************************************************
;** Eksperimentaalne mutipeletaja mis genereerib muutuva sageduse, kestuse ja *****
;** pausiga karjeid. Juhusliku arvu generaatori rutiin prit Microchip'i nitest **
;** felch@staff.ttu.ee
;** VABAKS kasutamiseks kigile huvilistele
; 1.5.: sama skeem PIC12F629 jaoks
; 25.9.09.: ujuva sagedusega prks lisatud. 629 kood ttab muudatusteta 675-l !
;**********************************************************************************
; Prose
;  						LIST P=12F683
  						LIST P=12F629
	include "P12F629.inc"  	
;	include "P12F683.inc"  	
; 	__CONFIG _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _BOD_OFF & _MCLRE_OFF & _WDT_OFF & _CP_OFF & _CPD_OFF   
 	__CONFIG _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _CP_OFF & _CPD_OFF
 				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305
				errorlevel -306 
;******* mlu jaotus ***************************************
        #DEFINE RANDHI  0020                    ;RANDOM NUMBER MSD REGISTER
        #DEFINE RANDLO  0021                    ;RANDOM NUMBER LSD REGISTER
;
        #DEFINE DELAY1  0023                    ; viiteaegade juures
        #DEFINE CCNTU   0025                    ; 
        #DEFINE CCNTL   0026                    ; 
        #DEFINE RTMP1   0027                    ; juhusliku arvu generis
        #DEFINE RTMP2   0028                    ; ''
        #DEFINE FREQ_LO 0029                    ; piiksu sagedus
        #DEFINE FREQ_LOT 002A                   

        #DEFINE CCNTL1 002B
        #DEFINE CCNTH1 002C
;****** raudwrk *********************************************
        #DEFINE OUTP    GPIO,.4                  ; mlemad piesosummerid (paralleelis)  kib nende kahe otsa vahele
        #DEFINE OUTM    GPIO,.5                  ; mlemad piesosummerid (paralleelis)  kib nende kahe otsa vahele
;***** prose lipukesed ***************************************
#define			ZERO		STATUS,Z
#define			CARRY		STATUS,C
#define			pank		STATUS,RP0

;***************************************************************
;**** Start ****************************************************
;***************************************************************
	ORG	0X00
	GOTO	MAIN		
;**** Katkestuste vektor. Katkestusi siin koodis ei pruugi *****
	ORG	0008		
	retfie			
;*************** Ja hakkab pihta.... ***************************
MAIN:	CALL 	init							; majapidamine parlanksi
MAIN1:	CALL	RANDOM							; tekita juhuslik 2-baidine arv
		call	PohiPiiks						; tekita karje
		CALL	RANDOM							; jrgmine juhuslik arv...
		CALL	PAUS							; ...annab vaikuse pausi kestuse
		CALL	BURST_40						; tekita 40 kHz sagedusega karje, kestus ja korduste arv juhuslik
		GOTO	MAIN1							; ratas kib ringi...

;***************************************************************
;**************** alamprogrammid *******************************
;***************************************************************

;**************** fikseeritud sagedusega (40 kHz) piuks ********
;*** seda koos juhusliku kestusega pausiga korratakse juhuslik *
;********* arv kordi *******************************************
BURST_40:	CALL	RANDOM
			movf	RANDHI,W					; pulsside paketi kestus
			movwf	CCNTU
burst40_1:	BSF		OUTM						; tekitame 40 kHz pulsi
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			BCF     OUTM						; ja teistpidi
			bsf		OUTP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			bcf		OUTP
			movf	RANDLO,W					; juhusliku kestusega paus
			movwf	CCNTL			
burst40_2:	DECFSZ	CCNTL,F	
			GOTO	burst40_2		
			DECFSZ	CCNTU,F						; koradame juhusliku arvu kordi
			GOTO	burst40_1		
			return
;******************* Phipiiks. Kik parameetrid juhuslikud **************
PohiPiiks:	movf	FREQ_LO,W					; seivi sagedus
			movwf	FREQ_LOT
			BSF		OUTM						; vljund hte pidi pingestatuks
PohiPiiks1:	NOP
			decfsz	FREQ_LOT,F
			goto	PohiPiiks1
			movf	FREQ_LO,W					; seivi sagedus
			movwf	FREQ_LOT
			BCF     OUTM						; vljund teist pidi
			bsf		OUTP
PohiPiiks2:	NOP
			decfsz	FREQ_LOT,F
			goto	PohiPiiks2
			bcf		OUTP						; 1 periood tekitatud
	decf FREQ_LO,F		;vhendame sagedust

			DECFSZ	CCNTL,F						; moluta kuni aeg tis saab
			GOTO	PohiPiiks
			DECFSZ	CCNTU,F		
			GOTO	PohiPiiks		
			return				
;************* juhusliku arvu generaator *********************************
RANDOM:		RLF	RANDHI,0						;GENERATES RANDOM NUMBER IN RANDHI		
			XORWF	RANDHI,0					;AND RANDLO
			MOVWF	RTMP1						;SIMULATES TAPPED SHIFT REGISTER
			SWAPF	RANDHI,1					;WITH XOR FEEDBACK
			SWAPF	RANDLO,0				
			MOVWF	RTMP2					
			RLF	RTMP2,0		
			RLF	RTMP2,1
			MOVF	RTMP2,0
			XORWF	RANDHI,0
			SWAPF	RANDHI,1
			ANDLW	0X01
			RLF	RTMP1,1
			RLF	RANDLO,1
			XORWF	RANDLO,1
			RLF	RANDHI,1						;RANDOM NUMBER NOW IN PLACE

			movf	RANDLO,W
			movwf	CCNTL1
			movf	RANDHI,W
			andlw	0x0F
			movwf	CCNTH1
			movf	RANDLO,W
			andlw	0x2F
			movwf	FREQ_LO
RANDXX:		movf	FREQ_LO,W
			btfsc	ZERO
			movlw	.1
			movwf	FREQ_LO						; madalsagedusliku piiksu sagedus on juhuslik
			movlw	.1
			movwf	CCNTU
			movf	RANDLO,W
			movwf	CCNTL
			RETLW	0X00		
;******************** tekitab juhusliku kestusega pausi piiksude vahele ****************
PAUS:		DECFSZ	CCNTL1,1		
			GOTO	PAUS1		
			DECFSZ	CCNTH1,1		
PAUS1:		GOTO	PAUS2		
			RETURN		        
PAUS2:		MOVLW	0x1F		
			MOVWF	DELAY1		
PAUS3:		DECFSZ	DELAY1,1
			GOTO	PAUS3		
			GOTO	PAUS	
;===============================================================================
; ******* initsialiseerimine *******
;===============================================================================
init:
;**** PIC12F683 puhul ****
;; **** llata 4MHz sisemisele generile ****
;				bsf     pank      		 
;				movlw	0x66
;				movwf 	OSCCON 					; 4MHz sisemine taktigene
;**** PIC12F629 puhul ****
; **** kalibreeri sisemine gener ****
				bsf     pank      		 
				call 	3FFh 					
				movwf 	OSCCAL 					; Kalibreeri sisemine taktigene
; **** konf ****
				MOVLW	B'11000000'				; pull-up'id maha
				movwf   OPTION_REG      		; 1:1 prescaler T0-le, sisemine takt, WPU lubatud 
; **** pordid ****
				bcf     pank
				clrf	GPIO					; pordid nulli
				movlw 	0x07					; analoog komparaator vlja
				movwf 	CMCON;0 
;				movwf 	CMCON0 
				bsf     pank 

;				clrf	ANSEL

				movlw	0x00					; kik vljunditeks
				movwf 	TRISIO 
				movlw	0x00					; WPU-d maha
				movwf	WPU
				bcf     pank 
				movlw	0x00					; esialgu biiperi otsad nulli
				movwf 	GPIO 
;
				MOVLW	0x20					; nulli muutujad (mlu alates 20H kuni 3FH)
				MOVWF	FSR		 
NXREG:			CLRF	INDF 		
				INCF	FSR,F
				BTFSC	FSR,.5	
				GOTO	NXREG		
				MOVLW	0X45					; initsialiseeri juhusliku arvu generaator
				MOVWF	RANDLO				
				MOVLW	0X30	
				MOVWF	RANDHI		
    			return  

	END		; aitab kah... :)
